/*

    MiniMono Example 2

    (C) Eugene Karataev

    http://www.minimdb.com
    support@minimdb.com


    Example demonstrates how to execute series of MUMPS commands

*/

class example2
{
	public static void main(String[] args)
	{
		try
		{
			String CodePage = "Cp1251";
			System.out.println("Java example2 how to call MiniMono");

			minimonoj MiniMono = new minimonoj( CodePage);
			minimonoj.MiniMonoVM init = new minimonoj.MiniMonoVM( CodePage);

			MiniMono.GetDefaultSettings( init);

			init.DataFile = "sys.dat";
			init.JournalingEnabled = 0;

			int ret = MiniMono.CreateMiniMono( init);
			System.out.println("MiniMono creation error: " + ret);
			
			int n = 5;
			MiniMono.Execute( "f i=1:1:" + n + " s a(i)=i*i");

			for( int i = 1; i <= n; i++)
			{
				System.out.println( "Value of a(" + i + ") is: " + MiniMono.Read( "a(" + i + ")"));
			}

			MiniMono.FreeMiniMono();

		}
		catch(Throwable e)
		{
			e.printStackTrace();
		}
		return;
	};
};