/*

    MiniMono Example 4

    (C) Eugene Karataev

    http://www.minimdb.com
    support@minimdb.com


    Example demonstrates how to setup some of DLL device event handlers

*/

class minimonodev4 extends minimonoj
{
	minimonodev4( String _CodePage)
		throws java.lang.Exception
	{
		super( _CodePage);
	};

	// overload functions for device handlers
	public int DevWriteStr( String str)
	{
		System.out.println( "Fired WriteStr(\"" + str + "\") event");
		return 0;
	};
	public int DevWriteChar( int _Char)
	{
		System.out.println( "Fired WriteChar(" + _Char + ") event");
		return 0;
	};
	public int DevWriteNL()
	{
		System.out.println( "Fired WriteNL event");
		return 0;
	};
	public int DevWriteFF()
	{
		System.out.println( "Fired WriteFF event");
		return 0;
	};
	public int DevWriteTab( int tabcount)
	{
		System.out.println( "Fired WriteTab(" + tabcount + ") event");
		return 0;
	};
};

class example4
{
	public static void main(String[] args)
	{
		try
		{
			String CodePage = "Cp1251";
			System.out.println("Java example1 how to call MiniMono");

			minimonodev4 MiniMono = new minimonodev4( CodePage);
			minimonoj.MiniMonoVM init = new minimonoj.MiniMonoVM( CodePage);

			MiniMono.GetDefaultSettings( init);

			init.DataFile = "sys.dat";
			init.JournalingEnabled = 0;

			int ret = MiniMono.CreateMiniMono( init);
			System.out.println("MiniMono creation error: " + ret);
			
			MiniMono.Execute( "write \"string\",*46,?12,!,#");
	
			MiniMono.FreeMiniMono();

		}
		catch(Throwable e)
		{
			e.printStackTrace();
		}
		return;
	};
};