/*

    MiniMono Example 5

    (C) Eugene Karataev

    http://www.minimdb.com
    support@minimdb.com


    Example demonstrates how to directly call globals and locals

*/

class example5
{
	public static void main(String[] args)
	{
		try
		{
			String CodePage = "Cp1251";
			System.out.println("Java example5 how to call MiniMono");

			minimonoj MiniMono = new minimonoj( CodePage);
			minimonoj.MiniMonoVM init = new minimonoj.MiniMonoVM( CodePage);

			MiniMono.GetDefaultSettings( init);

			init.DataFile = "sys.dat";
			init.JournalingEnabled = 0;

			int ret = MiniMono.CreateMiniMono( init);
			System.out.println("MiniMono creation error: " + ret);
			
			int limit = 8;

			// create globals using command execution
			MiniMono.Execute( "f i=0:1:8 s ^var(i,i*i)=i*i*i");

			// read global values using direct call
			String[] Indices = new String[ 2];

			for( int i = 0; i < limit; i++)
			{
				Indices[ 0] = Integer.toString( i);
				Indices[ 1] = Integer.toString( i * i);
				System.out.println( MiniMono.ReadGlobal( "var", Indices));
			}
			
			// kill global using direct call
			// and remove unsubscripted global name
			MiniMono.KillGlobal( "var", null);

			// create globals using direct call
			for( int i = 0; i < limit; i++)
			{
				Indices[ 0] = Integer.toString( i);
				Indices[ 1] = Integer.toString( i * i);
				MiniMono.WriteGlobal( "var", Indices, Integer.toString( i * i * i));
			}

			// read globals using expression evaluation
			for( int i = 0; i < limit; i++)
			{
				System.out.println( MiniMono.Read( "^var(" + Integer.toString( i) + "," 
					+ Integer.toString( i * i) + ")"));
			}

			MiniMono.FreeMiniMono();

		}
		catch(Throwable e)
		{
			e.printStackTrace();
		}
		return;
	};
};// 
