/*

    MiniMono Example 6

    (C) Eugene Karataev

    http://www.minimdb.com
    support@minimdb.com


    Example demonstrates how to create routine and call it

*/

class minimonodev6 extends minimonoj
{
	minimonodev6( String _CodePage)
		throws java.lang.Exception
	{
		super( _CodePage);
	};

	// overload functions for device handlers
	public int DevWriteStr( String str)
	{
		System.out.print( str);
		return 0;
	};
	public int DevWriteChar( int _Char)
	{
		char ch = (char)_Char;
		System.out.println( ch);
		return 0;
	};
	public int DevWriteNL()
	{
		System.out.println( "");
		return 0;
	};
	public int DevWriteFF()
	{
		System.out.println( "");
		return 0;
	};
	public int DevWriteTab( int tabcount)
	{
		System.out.print( " ");
		return 0;
	};
};

class example6
{
	public static void main(String[] args)
	{
		try
		{
			String CodePage = "Cp1251";
			System.out.println("Java example6 how to call MiniMono");

			minimonoj MiniMono = new minimonodev6( CodePage);
			minimonoj.MiniMonoVM init = new minimonoj.MiniMonoVM( CodePage);

			MiniMono.GetDefaultSettings( init);

			init.DataFile = "sys.dat";
			init.JournalingEnabled = 0;

			int ret = MiniMono.CreateMiniMono( init);
			System.out.println("MiniMono creation error: " + ret);

			// kill routine before create new
			String global_name = "ROUTINE";
			String routine_name = "Example6";
			String[] indices = new String[ 1];
			indices[ 0] = routine_name;
			MiniMono.KillGlobal( global_name, indices);

			// create routine as a series of direct global sets
			indices = new String[ 2];
			indices[ 0] = routine_name;

			String[] routine_text = 
			{
			  "Func(arg)",
			  " w \"arg = \",arg,!",
			  " n expr=$zd($h,8)",
			  " q expr"
			};
			for( int i = 0; i < routine_text.length; i++)
			{
				indices[ 1] = Integer.toString( i + 1);
				MiniMono.WriteGlobal( global_name, indices, routine_text[ i]);
			}

			// compile routine
			MiniMono.Read( "$v(\"rou\",\"c\",\"" + routine_name + "\")");

			// evaluate expression
			String func_result = MiniMono.Read( "$$Func^" + routine_name + "(\"any data\")");
			
			// show evaluation result
			System.out.println( "Function result: " + func_result);

			MiniMono.FreeMiniMono();

		}
		catch(Throwable e)
		{
			e.printStackTrace();
		}
		return;
	};
};
