/*

    MiniM ZDLL example 1

    ZDLL module export several functions to illistrate ZDLL interface usage.

*/

#include <windows.h>
#include <memory.h>

#include "zdll.h"

// zdll function which called from minim
int __stdcall concat( ZDLLCB* cbfunc, MINIM_STR* result,
  int argc, MINIM_STR** argv)
{
  if( argc != 2)
  {
    // currently accept only 2 parameters 
    return 1;
  }
  // concatenate _a and _b as strings into result

  // get _a and _b data as strings
  MINIM_STR a;
  MINIM_STR b;
  cbfunc->GetStr( argv[ 0], &a);
  cbfunc->GetStr( argv[ 1], &b);

  // check total lenght
  if( a.len + b.len > MINIM_STR_MAX)
  {
    // total lenght exceed maximum possible
    return 1;
  }

  // copy a into result
  memcpy( result->data, a.data, a.len);

  // append b to result
  memcpy( result->data + a.len, b.data, b.len);

  // set used lenght
  result->len = a.len + b.len;

  return 0;
};

// declare array of function definitions
ZDLLFUNC functions[] =
{
  { concat, "concat"},
  { NULL, NULL }
};

// root export
#ifdef __cplusplus
extern "C"
#endif
__declspec( dllexport ) ZDLLFUNC* __stdcall ZDLL ( void)
{
  return functions;
};

#pragma argsused
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void* lpReserved)
{
  switch( reason)
  {
    case DLL_PROCESS_ATTACH:
      // library load in progress
      break;
    case DLL_PROCESS_DETACH:
      // library unload in progress
      break;
  }
  return 1;
};
